program Discesa;

uses LexLib;

const
  htmlCode=10;
  htmlfineCode=20;
  bodyCode=30;
  bodyfineCode=40;
  headCode=50;
  headfineCode=60;
  titleCode=70;
  titlefineCode=80;
  stringaCode=90;
  linkcode=100;
  fileCode=110;
  linkfineCode=120;
  errorCode=500;

  maxS=100;

type
  list = ^node;
  node = record
           key: string;
           next: list;
         end;

var
  token: integer;
  current: string;
  stringinput: string;
  stack: list;
  tabsym: array[1..maxS] of string;
  N: integer;

function yylex:integer; forward;
procedure ErrorProc; forward;
Procedure Header; forward;
Procedure Main; Forward;
Procedure Link; Forward;
Procedure Add2Stack(link: string); Forward;


Procedure AvanzaToken;
begin
  token:=yylex;
end;

Procedure ErrorProc;
begin
  if token=errorCode then
    writeln(current,' Errore lessicale ',yytext)
  else
    Writeln(current,' Errore sintattico ',yytext);
  halt(0);
end;

Procedure Main;
begin
  if token=htmlcode then
  begin
    avanzatoken;
    Header;
  end
  else
    errorproc;
  if token=bodyCode then
  begin
    avanzatoken;
    while (token=stringacode) or (token=linkcode) do
    begin
      if token=linkcode then
        Link
      else
        avanzatoken;
    end;
    if token=bodyfinecode then
    begin
      avanzatoken;
      if token<>htmlfinecode then
        errorproc
    end
    else
      errorproc
  end
  else
    errorproc;
end;

Procedure Link;
begin
  if token=linkcode then
  begin
    avanzatoken;
    if token=filecode then
    begin
      add2stack(yytext);
      avanzatoken;
      if token=linkfinecode then
        avanzatoken
      else
        errorproc
    end
    else
      errorproc
  end
end;

Procedure Header;
begin
  if token=headcode then
  begin
    avanzatoken;
    if token=titlecode then
    begin
      avanzatoken;
      while token=stringacode do
        avanzatoken;
      if token=titlefinecode then
      begin
        avanzatoken;
        if token=headfinecode then
          avanzatoken
        else
          errorproc
      end
      else
        errorproc
    end
    else
      errorproc
  end
  else
    errorproc
end;

{$I progetto.pas}

procedure Push(link: string);
var
  temp: list;
begin
  new(temp);
  temp^.key:=link;
  temp^.next:=stack;
  stack:=temp;
end;

function Pop: string;
begin
  pop:=stack^.key;
  stack:=stack^.next;
end;

procedure add2stack(link: string);
var
  i: integer;
  visited: boolean;
begin
  if link=current then
  begin
    writeln(link,' Non sono ammessi link verso la stessa pagina!');
    halt(0);
  end;
  i:=0;
  visited:=false;
  repeat
    i:=i+1;
    if tabsym[i]=link then
      visited:=true;
  until (visited) or (i=N);
  if (N=maxS) and (not visited) then
  begin
    writeln('Troppi link!');
    halt(0);
  end;
  if not visited then
  begin
    push(link);
    N:=N+1;
    tabsym[N]:=link;
  end;
end;

procedure Analizza(link: string);
begin
  assign(yyinput, link);
  assign(yyoutput, '');
  reset(yyinput);
  rewrite(yyoutput);
  avanzatoken;
  Main;
  writeln(current,' riconosciuto!!');
  close(yyoutput);
  close(yyinput);
end;

begin
  if paramcount<>1 then
  begin
    writeln;
    writeln('Usage:  Prog nome.htm');
    halt(0);
  end;
  new(stack);
  stack:=nil;
  N:=1;
  tabsym[1]:=ParamStr(1);
  Push(ParamStr(1));
  while stack<>nil do
  begin
    current:=pop;
    analizza(current);
  end;
end.