%{ 
uses Lexlib, YaccLib;

const
  maxS=100;

type
  list = ^node;
  node = record
           key: string;
           next: list;
         end;

var
  token: integer;
  current: string;
  stringinput: string;
  stack: list;
  tabsym: array[1..maxS] of string;
  N: integer;

procedure Push(link: string);
var
  temp: list;
begin
  new(temp);
  temp^.key:=link;
  temp^.next:=stack;
  stack:=temp;
end;

function Pop: string;
begin
  pop:=stack^.key;
  stack:=stack^.next;
end;

procedure add2stack(link: string);
var
  i: integer;
  visited: boolean;
begin
  if link=current then
  begin
    writeln(link,' Non sono ammessi link verso la stessa pagina!');
    halt(0);
  end;
  i:=0;
  visited:=false;
  repeat
    i:=i+1;
    if tabsym[i]=link then
      visited:=true;
  until (visited) or (i=N);
  if (N=maxS) and (not visited) then
  begin
    writeln('Troppi link!');
    halt(0);
  end;
  if not visited then
  begin
    push(link);
    N:=N+1;
    tabsym[N]:=link;
  end;
end;


%}

%token htmlCode htmlfineCode bodyCode bodyfineCode headCode headfineCode titleCode
%token titlefineCode stringaCode linkCode fileCode linkfineCode errorCode

%%


START     : htmlCode HEAD BODY htmlfineCode
          ;

HEAD      : headCode titleCode STRINGA titlefineCode headfineCode
          ;

LINK      : linkCode fileCode {add2stack(yytext);} linkfineCode
          ;

BODY      : bodyCode BODYINT bodyfineCode
          ;

BODYINT   :
          | STRINGA BODYINT
          | LINK BODYINT
          ;


STRINGA   :
          | stringaCode STRINGA
          ;

%%

{$I PROGETTO.PAS}

begin
  if paramcount<>1 then
  begin
    writeln;
    writeln('Usage:  Prog nome.htm');
    halt(0);
  end;
  new(stack);
  stack:=nil;
  N:=1;
  tabsym[1]:=ParamStr(1);
  Push(ParamStr(1));
  while stack<>nil do
  begin
    current:=pop;
    assign(yyoutput, '');
    rewrite(yyoutput);
    assign(yyinput, current);
    reset(yyinput);
    if yyparse=0 then
    begin
      writeln(current,' riconosciuto!!');
    end
    else
    begin
      writeln(current,' non riconosciuto!!');
      halt(0);
    end;
  end;
end.