
(* Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG *)

(* global definitions: *)
 
uses Lexlib, YaccLib;

const
  maxS=100;

type
  list = ^node;
  node = record
           key: string;
           next: list;
         end;

var
  token: integer;
  current: string;
  stringinput: string;
  stack: list;
  tabsym: array[1..maxS] of string;
  N: integer;

procedure Push(link: string);
var
  temp: list;
begin
  new(temp);
  temp^.key:=link;
  temp^.next:=stack;
  stack:=temp;
end;

function Pop: string;
begin
  pop:=stack^.key;
  stack:=stack^.next;
end;

procedure add2stack(link: string);
var
  i: integer;
  visited: boolean;
begin
  if link=current then
  begin
    writeln(link,' Non sono ammessi link verso la stessa pagina!');
    halt(0);
  end;
  i:=0;
  visited:=false;
  repeat
    i:=i+1;
    if tabsym[i]=link then
      visited:=true;
  until (visited) or (i=N);
  if (N=maxS) and (not visited) then
  begin
    writeln('Troppi link!');
    halt(0);
  end;
  if not visited then
  begin
    push(link);
    N:=N+1;
    tabsym[N]:=link;
  end;
end;


const htmlCode = 257;
const htmlfineCode = 258;
const bodyCode = 259;
const bodyfineCode = 260;
const headCode = 261;
const headfineCode = 262;
const titleCode = 263;
const titlefineCode = 264;
const stringaCode = 265;
const linkCode = 266;
const fileCode = 267;
const linkfineCode = 268;
const errorCode = 269;

var yylval : YYSType;

function yylex : Integer; forward;

function yyparse : Integer;

var yystate, yysp, yyn : Integer;
    yys : array [1..yymaxdepth] of Integer;
    yyv : array [1..yymaxdepth] of YYSType;
    yyval : YYSType;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         yyval := yyv[yysp-3];
       end;
   2 : begin
         yyval := yyv[yysp-4];
       end;
   3 : begin
         add2stack(yytext);
       end;
   4 : begin
         yyval := yyv[yysp-3];
       end;
   5 : begin
         yyval := yyv[yysp-2];
       end;
   6 : begin
       end;
   7 : begin
         yyval := yyv[yysp-1];
       end;
   8 : begin
         yyval := yyv[yysp-1];
       end;
   9 : begin
       end;
  10 : begin
         yyval := yyv[yysp-1];
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 26;
yyngotos  = 15;
yynstates = 24;
yynrules  = 10;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 257; act: 2 ),
{ 1: }
  ( sym: 0; act: 0 ),
{ 2: }
  ( sym: 261; act: 4 ),
{ 3: }
  ( sym: 259; act: 6 ),
{ 4: }
  ( sym: 263; act: 7 ),
{ 5: }
  ( sym: 258; act: 8 ),
{ 6: }
  ( sym: 265; act: 12 ),
  ( sym: 266; act: 13 ),
  ( sym: 260; act: -6 ),
{ 7: }
  ( sym: 265; act: 12 ),
  ( sym: 264; act: -9 ),
{ 8: }
{ 9: }
  ( sym: 260; act: 15 ),
{ 10: }
  ( sym: 265; act: 12 ),
  ( sym: 266; act: 13 ),
  ( sym: 260; act: -6 ),
{ 11: }
  ( sym: 265; act: 12 ),
  ( sym: 266; act: 13 ),
  ( sym: 260; act: -6 ),
{ 12: }
  ( sym: 265; act: 12 ),
  ( sym: 260; act: -9 ),
  ( sym: 264; act: -9 ),
  ( sym: 266; act: -9 ),
{ 13: }
  ( sym: 267; act: 19 ),
{ 14: }
  ( sym: 264; act: 20 ),
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
  ( sym: 262; act: 22 ),
{ 21: }
  ( sym: 268; act: 23 )
{ 22: }
{ 23: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -2; act: 1 ),
{ 1: }
{ 2: }
  ( sym: -3; act: 3 ),
{ 3: }
  ( sym: -4; act: 5 ),
{ 4: }
{ 5: }
{ 6: }
  ( sym: -8; act: 9 ),
  ( sym: -6; act: 10 ),
  ( sym: -5; act: 11 ),
{ 7: }
  ( sym: -5; act: 14 ),
{ 8: }
{ 9: }
{ 10: }
  ( sym: -8; act: 16 ),
  ( sym: -6; act: 10 ),
  ( sym: -5; act: 11 ),
{ 11: }
  ( sym: -8; act: 17 ),
  ( sym: -6; act: 10 ),
  ( sym: -5; act: 11 ),
{ 12: }
  ( sym: -5; act: 18 ),
{ 13: }
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
  ( sym: -7; act: 21 )
{ 20: }
{ 21: }
{ 22: }
{ 23: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } 0,
{ 5: } 0,
{ 6: } 0,
{ 7: } 0,
{ 8: } -1,
{ 9: } 0,
{ 10: } 0,
{ 11: } 0,
{ 12: } 0,
{ 13: } 0,
{ 14: } 0,
{ 15: } -5,
{ 16: } -8,
{ 17: } -7,
{ 18: } -10,
{ 19: } -3,
{ 20: } 0,
{ 21: } 0,
{ 22: } -2,
{ 23: } -4
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 4,
{ 4: } 5,
{ 5: } 6,
{ 6: } 7,
{ 7: } 10,
{ 8: } 12,
{ 9: } 12,
{ 10: } 13,
{ 11: } 16,
{ 12: } 19,
{ 13: } 23,
{ 14: } 24,
{ 15: } 25,
{ 16: } 25,
{ 17: } 25,
{ 18: } 25,
{ 19: } 25,
{ 20: } 25,
{ 21: } 26,
{ 22: } 27,
{ 23: } 27
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 4,
{ 4: } 5,
{ 5: } 6,
{ 6: } 9,
{ 7: } 11,
{ 8: } 11,
{ 9: } 12,
{ 10: } 15,
{ 11: } 18,
{ 12: } 22,
{ 13: } 23,
{ 14: } 24,
{ 15: } 24,
{ 16: } 24,
{ 17: } 24,
{ 18: } 24,
{ 19: } 24,
{ 20: } 25,
{ 21: } 26,
{ 22: } 26,
{ 23: } 26
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 2,
{ 3: } 3,
{ 4: } 4,
{ 5: } 4,
{ 6: } 4,
{ 7: } 7,
{ 8: } 8,
{ 9: } 8,
{ 10: } 8,
{ 11: } 11,
{ 12: } 14,
{ 13: } 15,
{ 14: } 15,
{ 15: } 15,
{ 16: } 15,
{ 17: } 15,
{ 18: } 15,
{ 19: } 15,
{ 20: } 16,
{ 21: } 16,
{ 22: } 16,
{ 23: } 16
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 2,
{ 3: } 3,
{ 4: } 3,
{ 5: } 3,
{ 6: } 6,
{ 7: } 7,
{ 8: } 7,
{ 9: } 7,
{ 10: } 10,
{ 11: } 13,
{ 12: } 14,
{ 13: } 14,
{ 14: } 14,
{ 15: } 14,
{ 16: } 14,
{ 17: } 14,
{ 18: } 14,
{ 19: } 15,
{ 20: } 15,
{ 21: } 15,
{ 22: } 15,
{ 23: } 15
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 4; sym: -2 ),
{ 2: } ( len: 5; sym: -3 ),
{ 3: } ( len: 0; sym: -7 ),
{ 4: } ( len: 4; sym: -6 ),
{ 5: } ( len: 3; sym: -4 ),
{ 6: } ( len: 0; sym: -8 ),
{ 7: } ( len: 2; sym: -8 ),
{ 8: } ( len: 2; sym: -8 ),
{ 9: } ( len: 0; sym: -5 ),
{ 10: } ( len: 2; sym: -5 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)

  yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>yymaxdepth then
    begin
      yyerror('yyparse stack overflow');
      goto abort;
    end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then writeln('state ', yystate, ', char ', yychar);

  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error');

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              writeln('error recovery pops state ', yys[yysp], ', uncovers ',
                      yys[yysp-1])
            else
              writeln('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then writeln('error recovery discards char ', yychar);
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then writeln('reduce ', -yyn);

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0; exit;

abort:

  yyparse := 1; exit;

end(*yyparse*);


{$I PROGETTO.PAS}

begin
  if paramcount<>1 then
  begin
    writeln;
    writeln('Usage:  Prog nome.htm');
    halt(0);
  end;
  new(stack);
  stack:=nil;
  N:=1;
  tabsym[1]:=ParamStr(1);
  Push(ParamStr(1));
  while stack<>nil do
  begin
    current:=pop;
    assign(yyoutput, '');
    rewrite(yyoutput);
    assign(yyinput, current);
    reset(yyinput);
    if yyparse=0 then
    begin
      writeln(current,' riconosciuto!!');
    end
    else
    begin
      writeln(current,' non riconosciuto!!');
      halt(0);
    end;
  end;
end.